diff -ruNp linux-2.6.26.1/fs/read_write.c linux-2.6.26.1-cher1/fs/read_write.c
--- linux-2.6.26.1/fs/read_write.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/read_write.c	2008-08-05 13:44:37.000000000 +0400
@@ -134,6 +134,9 @@ asmlinkage off_t sys_lseek(unsigned int 
 	struct file * file;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	retval = -EBADF;
 	file = fget_light(fd, &fput_needed);
 	if (!file)
@@ -161,6 +164,9 @@ asmlinkage long sys_llseek(unsigned int 
 	loff_t offset;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	retval = -EBADF;
 	file = fget_light(fd, &fput_needed);
 	if (!file)
@@ -391,6 +397,9 @@ asmlinkage ssize_t sys_pread64(unsigned 
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -412,6 +421,9 @@ asmlinkage ssize_t sys_pwrite64(unsigned
 	ssize_t ret = -EBADF;
 	int fput_needed;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (pos < 0)
 		return -EINVAL;
 
@@ -799,6 +811,9 @@ asmlinkage ssize_t sys_sendfile(int out_
 	off_t off;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (offset) {
 		if (unlikely(get_user(off, offset)))
 			return -EFAULT;
@@ -817,6 +832,9 @@ asmlinkage ssize_t sys_sendfile64(int ou
 	loff_t pos;
 	ssize_t ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (offset) {
 		if (unlikely(copy_from_user(&pos, offset, sizeof(loff_t))))
 			return -EFAULT;
@@ -828,3 +846,9 @@ asmlinkage ssize_t sys_sendfile64(int ou
 
 	return do_sendfile(out_fd, in_fd, NULL, count, 0);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/signalfd.c linux-2.6.26.1-cher1/fs/signalfd.c
--- linux-2.6.26.1/fs/signalfd.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/signalfd.c	2008-08-05 13:44:37.000000000 +0400
@@ -210,6 +210,9 @@ asmlinkage long sys_signalfd(int ufd, si
 	sigset_t sigmask;
 	struct signalfd_ctx *ctx;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sizemask != sizeof(sigset_t) ||
 	    copy_from_user(&sigmask, user_mask, sizeof(sigmask)))
 		return -EINVAL;
@@ -249,3 +252,9 @@ asmlinkage long sys_signalfd(int ufd, si
 
 	return ufd;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/splice.c linux-2.6.26.1-cher1/fs/splice.c
--- linux-2.6.26.1/fs/splice.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/splice.c	2008-08-05 13:44:37.000000000 +0400
@@ -1464,6 +1464,9 @@ asmlinkage long sys_vmsplice(int fd, con
 	long error;
 	int fput;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (unlikely(nr_segs > UIO_MAXIOV))
 		return -EINVAL;
 	else if (unlikely(!nr_segs))
@@ -1491,6 +1494,9 @@ asmlinkage long sys_splice(int fd_in, lo
 	struct file *in, *out;
 	int fput_in, fput_out;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (unlikely(!len))
 		return 0;
 
@@ -1712,6 +1718,9 @@ asmlinkage long sys_tee(int fdin, int fd
 	struct file *in;
 	int error, fput_in;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (unlikely(!len))
 		return 0;
 
@@ -1733,3 +1742,9 @@ asmlinkage long sys_tee(int fdin, int fd
 
 	return error;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/stat.c linux-2.6.26.1-cher1/fs/stat.c
--- linux-2.6.26.1/fs/stat.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/stat.c	2008-08-05 13:44:37.000000000 +0400
@@ -155,8 +155,12 @@ static int cp_old_stat(struct kstat *sta
 asmlinkage long sys_stat(char __user * filename, struct __old_kernel_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat_fd(AT_FDCWD, filename, &stat);
+        int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = vfs_stat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_old_stat(&stat, statbuf);
 
@@ -165,8 +169,12 @@ asmlinkage long sys_stat(char __user * f
 asmlinkage long sys_lstat(char __user * filename, struct __old_kernel_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+        error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_old_stat(&stat, statbuf);
 
@@ -175,8 +183,12 @@ asmlinkage long sys_lstat(char __user * 
 asmlinkage long sys_fstat(unsigned int fd, struct __old_kernel_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+        error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_old_stat(&stat, statbuf);
 
@@ -238,8 +250,12 @@ static int cp_new_stat(struct kstat *sta
 asmlinkage long sys_newstat(char __user *filename, struct stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat_fd(AT_FDCWD, filename, &stat);
+	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = vfs_stat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_new_stat(&stat, statbuf);
 
@@ -249,8 +265,12 @@ asmlinkage long sys_newstat(char __user 
 asmlinkage long sys_newlstat(char __user *filename, struct stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+        error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_new_stat(&stat, statbuf);
 
@@ -264,6 +284,9 @@ asmlinkage long sys_newfstatat(int dfd, 
 	struct kstat stat;
 	int error = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -283,8 +306,12 @@ out:
 asmlinkage long sys_newfstat(unsigned int fd, struct stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_new_stat(&stat, statbuf);
 
@@ -297,6 +324,9 @@ asmlinkage long sys_readlinkat(int dfd, 
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (bufsiz <= 0)
 		return -EINVAL;
 
@@ -368,8 +398,12 @@ static long cp_new_stat64(struct kstat *
 asmlinkage long sys_stat64(char __user * filename, struct stat64 __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat(filename, &stat);
+	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = vfs_stat(filename, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -378,8 +412,12 @@ asmlinkage long sys_stat64(char __user *
 asmlinkage long sys_lstat64(char __user * filename, struct stat64 __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat(filename, &stat);
+	int error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        error = vfs_lstat(filename, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -388,8 +426,12 @@ asmlinkage long sys_lstat64(char __user 
 asmlinkage long sys_fstat64(unsigned long fd, struct stat64 __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
 
+        error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -402,6 +444,9 @@ asmlinkage long sys_fstatat64(int dfd, c
 	struct kstat stat;
 	int error = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -469,3 +514,9 @@ void inode_set_bytes(struct inode *inode
 }
 
 EXPORT_SYMBOL(inode_set_bytes);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/super.c linux-2.6.26.1-cher1/fs/super.c
--- linux-2.6.26.1/fs/super.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/super.c	2008-08-05 13:44:37.000000000 +0400
@@ -540,6 +540,9 @@ asmlinkage long sys_ustat(unsigned dev, 
         struct kstatfs sbuf;
 	int err = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
         s = user_get_super(new_decode_dev(dev));
         if (s == NULL)
                 goto out;
@@ -980,3 +983,9 @@ struct vfsmount *kern_mount_data(struct 
 }
 
 EXPORT_SYMBOL_GPL(kern_mount_data);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/sync.c linux-2.6.26.1-cher1/fs/sync.c
--- linux-2.6.26.1/fs/sync.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/sync.c	2008-08-05 13:44:37.000000000 +0400
@@ -38,6 +38,11 @@ static void do_sync(unsigned long wait)
 
 asmlinkage long sys_sync(void)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	do_sync(1);
 	return 0;
 }
@@ -120,11 +125,21 @@ static long __do_fsync(unsigned int fd, 
 
 asmlinkage long sys_fsync(unsigned int fd)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return __do_fsync(fd, 0);
 }
 
 asmlinkage long sys_fdatasync(unsigned int fd)
 {
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	return __do_fsync(fd, 1);
 }
 
@@ -183,6 +198,11 @@ asmlinkage long sys_sync_file_range(int 
 	int fput_needed;
 	umode_t i_mode;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	ret = -EINVAL;
 	if (flags & ~VALID_FLAGS)
 		goto out;
@@ -282,3 +302,9 @@ out:
 	return ret;
 }
 EXPORT_SYMBOL_GPL(do_sync_mapping_range);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/timerfd.c linux-2.6.26.1-cher1/fs/timerfd.c
--- linux-2.6.26.1/fs/timerfd.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/timerfd.c	2008-08-05 13:44:37.000000000 +0400
@@ -184,6 +184,9 @@ asmlinkage long sys_timerfd_create(int c
 	int ufd;
 	struct timerfd_ctx *ctx;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (flags)
 		return -EINVAL;
 	if (clockid != CLOCK_MONOTONIC &&
@@ -213,6 +216,9 @@ asmlinkage long sys_timerfd_settime(int 
 	struct timerfd_ctx *ctx;
 	struct itimerspec ktmr, kotmr;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (copy_from_user(&ktmr, utmr, sizeof(ktmr)))
 		return -EFAULT;
 
@@ -268,6 +274,9 @@ asmlinkage long sys_timerfd_gettime(int 
 	struct timerfd_ctx *ctx;
 	struct itimerspec kotmr;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	file = timerfd_fget(ufd);
 	if (IS_ERR(file))
 		return PTR_ERR(file);
@@ -288,3 +297,8 @@ asmlinkage long sys_timerfd_gettime(int 
 	return copy_to_user(otmr, &kotmr, sizeof(kotmr)) ? -EFAULT: 0;
 }
 
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/utimes.c linux-2.6.26.1-cher1/fs/utimes.c
--- linux-2.6.26.1/fs/utimes.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/utimes.c	2008-08-05 13:44:37.000000000 +0400
@@ -28,6 +28,11 @@ asmlinkage long sys_utime(char __user *f
 {
 	struct timespec tv[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (times) {
 		if (get_user(tv[0].tv_sec, &times->actime) ||
 		    get_user(tv[1].tv_sec, &times->modtime))
@@ -171,6 +176,11 @@ asmlinkage long sys_utimensat(int dfd, c
 {
 	struct timespec tstimes[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (utimes) {
 		if (copy_from_user(&tstimes, utimes, sizeof(tstimes)))
 			return -EFAULT;
@@ -189,6 +199,11 @@ asmlinkage long sys_futimesat(int dfd, c
 	struct timeval times[2];
 	struct timespec tstimes[2];
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (utimes) {
 		if (copy_from_user(&times, utimes, sizeof(times)))
 			return -EFAULT;
@@ -215,3 +230,9 @@ asmlinkage long sys_utimes(char __user *
 {
 	return sys_futimesat(AT_FDCWD, filename, utimes);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/xattr.c linux-2.6.26.1-cher1/fs/xattr.c
--- linux-2.6.26.1/fs/xattr.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/xattr.c	2008-08-05 13:44:37.000000000 +0400
@@ -258,6 +258,11 @@ sys_setxattr(const char __user *path, co
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -277,6 +282,11 @@ sys_lsetxattr(const char __user *path, c
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -297,6 +307,11 @@ sys_fsetxattr(int fd, const char __user 
 	struct dentry *dentry;
 	int error = -EBADF;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -356,6 +371,11 @@ sys_getxattr(const char __user *path, co
 	struct nameidata nd;
 	ssize_t error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -371,6 +391,11 @@ sys_lgetxattr(const char __user *path, c
 	struct nameidata nd;
 	ssize_t error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -385,6 +410,11 @@ sys_fgetxattr(int fd, const char __user 
 	struct file *f;
 	ssize_t error = -EBADF;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -430,6 +460,11 @@ sys_listxattr(const char __user *path, c
 	struct nameidata nd;
 	ssize_t error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -444,6 +479,11 @@ sys_llistxattr(const char __user *path, 
 	struct nameidata nd;
 	ssize_t error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -458,6 +498,11 @@ sys_flistxattr(int fd, char __user *list
 	struct file *f;
 	ssize_t error = -EBADF;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -491,6 +536,11 @@ sys_removexattr(const char __user *path,
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -509,6 +559,11 @@ sys_lremovexattr(const char __user *path
 	struct nameidata nd;
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -528,6 +583,11 @@ sys_fremovexattr(int fd, const char __us
 	struct dentry *dentry;
 	int error = -EBADF;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -669,3 +729,9 @@ EXPORT_SYMBOL(generic_getxattr);
 EXPORT_SYMBOL(generic_listxattr);
 EXPORT_SYMBOL(generic_setxattr);
 EXPORT_SYMBOL(generic_removexattr);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/include/asm-generic/resource.h linux-2.6.26.1-cher1/include/asm-generic/resource.h
--- linux-2.6.26.1/include/asm-generic/resource.h	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/include/asm-generic/resource.h	2008-08-05 13:44:37.000000000 +0400
@@ -45,7 +45,11 @@
 					   0-39 for nice level 19 .. -20 */
 #define RLIMIT_RTPRIO		14	/* maximum realtime priority */
 #define RLIMIT_RTTIME		15	/* timeout for RT tasks in us */
-#define RLIM_NLIMITS		16
+#define RLIMIT_FUTURE1          16      /* for future use */
+#define RLIMIT_FUTURE2          17      /* for future use */
+#define RLIMIT_FUTURE3          18      /* for future use */
+#define RLIMIT_MCPU             19      /* millisecond cpu limit */
+#define RLIM_NLIMITS		20
 
 /*
  * SuS says limits have to be unsigned.
@@ -87,6 +91,10 @@
 	[RLIMIT_NICE]		= { 0, 0 },				\
 	[RLIMIT_RTPRIO]		= { 0, 0 },				\
 	[RLIMIT_RTTIME]		= {  RLIM_INFINITY,  RLIM_INFINITY },	\
+	[RLIMIT_FUTURE1]        = { 0, 0 },				\
+	[RLIMIT_FUTURE2]        = { 0, 0 },				\
+	[RLIMIT_FUTURE3]        = { 0, 0 },				\
+        [RLIMIT_MCPU]           = {  RLIM_INFINITY,  RLIM_INFINITY },   \
 }
 
 #endif	/* __KERNEL__ */
diff -ruNp linux-2.6.26.1/include/linux/ptrace.h linux-2.6.26.1-cher1/include/linux/ptrace.h
--- linux-2.6.26.1/include/linux/ptrace.h	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/include/linux/ptrace.h	2008-08-05 13:44:37.000000000 +0400
@@ -27,6 +27,9 @@
 #define PTRACE_GETSIGINFO	0x4202
 #define PTRACE_SETSIGINFO	0x4203
 
+#define PTRACE_MEMLIMIT         0x4280
+#define PTRACE_NO_SYSCALLS      0x4281
+
 /* options set using PTRACE_SETOPTIONS */
 #define PTRACE_O_TRACESYSGOOD	0x00000001
 #define PTRACE_O_TRACEFORK	0x00000002
diff -ruNp linux-2.6.26.1/include/linux/sched.h linux-2.6.26.1-cher1/include/linux/sched.h
--- linux-2.6.26.1/include/linux/sched.h	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/include/linux/sched.h	2008-08-05 13:44:37.000000000 +0400
@@ -1023,6 +1023,15 @@ struct sched_rt_entity {
 #endif
 };
 
+/* sandbox flags */
+enum {
+        SBOX_NO_SYSCALLS  = 1,   /* disable most "dangerous" syscalls */
+        SBOX_NO_EXEC      = 2,   /* disable exec syscall */
+        SBOX_MEMLIMITON   = 4,   /* enable memory limit check */
+        SBOX_WAS_MEMLIMIT = 8,   /* memory limit happened  */
+        SBOX_WAS_SECURITY = 16,  /* was security violation */
+};
+
 struct task_struct {
 	volatile long state;	/* -1 unrunnable, 0 runnable, >0 stopped */
 	void *stack;
@@ -1303,8 +1312,16 @@ struct task_struct {
 	int latency_record_count;
 	struct latency_record latency_record[LT_SAVECOUNT];
 #endif
+        /* sandbox flags */
+        int sbox_flags;
 };
 
+#define SBOX_IS_RESTRICTED() unlikely(current->sbox_flags & SBOX_NO_SYSCALLS)
+#define SBOX_SET_SECURITY_ERR() (current->sbox_flags |= SBOX_WAS_SECURITY)
+
+#define SBOX_IS_MEMLIMIT_ERR(p) (p->sbox_flags & SBOX_WAS_MEMLIMIT)
+#define SBOX_IS_SECURITY_ERR(p) (p->sbox_flags & SBOX_WAS_SECURITY)
+
 /*
  * Priority of a process goes from 0..MAX_PRIO-1, valid RT
  * priority is 0..MAX_RT_PRIO-1, and SCHED_NORMAL/SCHED_BATCH
diff -ruNp linux-2.6.26.1/ipc/mqueue.c linux-2.6.26.1-cher1/ipc/mqueue.c
--- linux-2.6.26.1/ipc/mqueue.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/ipc/mqueue.c	2008-08-05 13:44:37.000000000 +0400
@@ -666,6 +666,9 @@ asmlinkage long sys_mq_open(const char _
 	char *name;
 	int fd, error;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	error = audit_mq_open(oflag, mode, u_attr);
 	if (error != 0)
 		return error;
@@ -733,6 +736,9 @@ asmlinkage long sys_mq_unlink(const char
 	struct dentry *dentry;
 	struct inode *inode = NULL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	name = getname(u_name);
 	if (IS_ERR(name))
 		return PTR_ERR(name);
@@ -832,6 +838,9 @@ asmlinkage long sys_mq_timedsend(mqd_t m
 	long timeout;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = audit_mq_timedsend(mqdes, msg_len, msg_prio, u_abs_timeout);
 	if (ret != 0)
 		return ret;
@@ -919,6 +928,9 @@ asmlinkage ssize_t sys_mq_timedreceive(m
 	struct mqueue_inode_info *info;
 	struct ext_wait_queue wait;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = audit_mq_timedreceive(mqdes, msg_len, u_msg_prio, u_abs_timeout);
 	if (ret != 0)
 		return ret;
@@ -1003,6 +1015,9 @@ asmlinkage long sys_mq_notify(mqd_t mqde
 	struct mqueue_inode_info *info;
 	struct sk_buff *nc;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = audit_mq_notify(mqdes, u_notification);
 	if (ret != 0)
 		return ret;
@@ -1128,6 +1143,9 @@ asmlinkage long sys_mq_getsetattr(mqd_t 
 	struct inode *inode;
 	struct mqueue_inode_info *info;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (u_mqstat != NULL) {
 		if (copy_from_user(&mqstat, u_mqstat, sizeof(struct mq_attr)))
 			return -EFAULT;
@@ -1294,3 +1312,9 @@ out_sysctl:
 }
 
 __initcall(init_mqueue_fs);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/ipc/msg.c linux-2.6.26.1-cher1/ipc/msg.c
--- linux-2.6.26.1/ipc/msg.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/ipc/msg.c	2008-08-05 13:44:37.000000000 +0400
@@ -315,6 +315,11 @@ asmlinkage long sys_msgget(key_t key, in
 	struct ipc_ops msg_ops;
 	struct ipc_params msg_params;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 
 	msg_ops.getnew = newque;
@@ -472,6 +477,11 @@ asmlinkage long sys_msgctl(int msqid, in
 	int err, version;
 	struct ipc_namespace *ns;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (msqid < 0 || cmd < 0)
 		return -EINVAL;
 
@@ -728,6 +738,11 @@ sys_msgsnd(int msqid, struct msgbuf __us
 {
 	long mtype;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (get_user(mtype, &msgp->mtype))
 		return -EFAULT;
 	return do_msgsnd(msqid, mtype, msgp->mtext, msgsz, msgflg);
@@ -909,6 +924,11 @@ asmlinkage long sys_msgrcv(int msqid, st
 {
 	long err, mtype;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	err =  do_msgrcv(msqid, &mtype, msgp->mtext, msgsz, msgtyp, msgflg);
 	if (err < 0)
 		goto out;
@@ -942,3 +962,9 @@ static int sysvipc_msg_proc_show(struct 
 			msq->q_ctime);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/ipc/sem.c linux-2.6.26.1-cher1/ipc/sem.c
--- linux-2.6.26.1/ipc/sem.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/ipc/sem.c	2008-08-05 13:44:37.000000000 +0400
@@ -315,6 +315,11 @@ asmlinkage long sys_semget(key_t key, in
 	struct ipc_ops sem_ops;
 	struct ipc_params sem_params;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 
 	if (nsems < 0 || nsems > ns->sc_semmsl)
@@ -899,6 +904,11 @@ asmlinkage long sys_semctl (int semid, i
 	int version;
 	struct ipc_namespace *ns;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (semid < 0)
 		return -EINVAL;
 
@@ -1052,6 +1062,11 @@ asmlinkage long sys_semtimedop(int semid
 	unsigned long jiffies_left = 0;
 	struct ipc_namespace *ns;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 
 	if (nsops < 1 || semid < 0)
@@ -1341,3 +1356,9 @@ static int sysvipc_sem_proc_show(struct 
 			  sma->sem_ctime);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/ipc/shm.c linux-2.6.26.1-cher1/ipc/shm.c
--- linux-2.6.26.1/ipc/shm.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/ipc/shm.c	2008-08-05 13:44:37.000000000 +0400
@@ -461,6 +461,11 @@ asmlinkage long sys_shmget (key_t key, s
 	struct ipc_ops shm_ops;
 	struct ipc_params shm_params;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 
 	shm_ops.getnew = newseg;
@@ -641,6 +646,11 @@ asmlinkage long sys_shmctl(int shmid, in
 	int err, version;
 	struct ipc_namespace *ns;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (cmd < 0 || shmid < 0) {
 		err = -EINVAL;
 		goto out;
@@ -960,6 +970,11 @@ asmlinkage long sys_shmat(int shmid, cha
 	unsigned long ret;
 	long err;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	err = do_shmat(shmid, shmaddr, shmflg, &ret);
 	if (err)
 		return err;
@@ -979,6 +994,11 @@ asmlinkage long sys_shmdt(char __user *s
 	loff_t size = 0;
 	int retval = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (addr & ~PAGE_MASK)
 		return retval;
 
@@ -1084,3 +1104,9 @@ static int sysvipc_shm_proc_show(struct 
 			  shp->shm_ctim);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/acct.c linux-2.6.26.1-cher1/kernel/acct.c
--- linux-2.6.26.1/kernel/acct.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/acct.c	2008-08-05 13:44:37.000000000 +0400
@@ -259,6 +259,11 @@ asmlinkage long sys_acct(const char __us
 {
 	int error;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_PACCT))
 		return -EPERM;
 
@@ -608,3 +613,9 @@ void acct_process(void)
 	fput(file);
 	put_pid_ns(ns);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/capability.c linux-2.6.26.1-cher1/kernel/capability.c
--- linux-2.6.26.1/kernel/capability.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/capability.c	2008-08-05 13:44:37.000000000 +0400
@@ -159,6 +159,9 @@ asmlinkage long sys_capget(cap_user_head
 	unsigned tocopy;
 	kernel_cap_t pE, pI, pP;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = cap_validate_magic(header, &tocopy);
 	if (ret != 0)
 		return ret;
@@ -317,6 +320,11 @@ asmlinkage long sys_capset(cap_user_head
 	int ret;
 	pid_t pid;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	ret = cap_validate_magic(header, &tocopy);
 	if (ret != 0)
 		return ret;
@@ -396,3 +404,9 @@ int capable(int cap)
 	return __capable(current, cap);
 }
 EXPORT_SYMBOL(capable);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/compat.c linux-2.6.26.1-cher1/kernel/compat.c
--- linux-2.6.26.1/kernel/compat.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/compat.c	2008-08-05 13:44:37.000000000 +0400
@@ -210,6 +210,9 @@ asmlinkage long compat_sys_sigpending(co
 	long ret;
 	mm_segment_t old_fs = get_fs();
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	set_fs(KERNEL_DS);
 	ret = sys_sigpending((old_sigset_t __user *) &s);
 	set_fs(old_fs);
@@ -225,6 +228,9 @@ asmlinkage long compat_sys_sigprocmask(i
 	long ret;
 	mm_segment_t old_fs;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (set && get_user(s, set))
 		return -EFAULT;
 	old_fs = get_fs();
@@ -441,6 +447,9 @@ asmlinkage long compat_sys_sched_setaffi
 	cpumask_t new_mask;
 	int retval;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	retval = compat_get_user_cpu_mask(user_mask_ptr, len, &new_mask);
 	if (retval)
 		return retval;
@@ -456,6 +465,9 @@ asmlinkage long compat_sys_sched_getaffi
 	unsigned long *k;
 	unsigned int min_length = sizeof(cpumask_t);
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (NR_CPUS <= BITS_PER_COMPAT_LONG)
 		min_length = sizeof(compat_ulong_t);
 
@@ -781,6 +793,9 @@ compat_sys_rt_sigtimedwait (compat_sigse
 	siginfo_t info;
 	long ret, timeout = 0;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
 
@@ -860,6 +875,11 @@ asmlinkage long compat_sys_stime(compat_
 	struct timespec tv;
 	int err;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (get_user(tv.tv_sec, tptr))
 		return -EFAULT;
 
@@ -908,6 +928,11 @@ asmlinkage long compat_sys_adjtimex(stru
 	struct timex txc;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	memset(&txc, 0, sizeof(struct timex));
 
 	if (!access_ok(VERIFY_READ, utp, sizeof(struct compat_timex)) ||
@@ -1039,6 +1064,9 @@ compat_sys_sysinfo(struct compat_sysinfo
 {
 	struct sysinfo s;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	do_sysinfo(&s);
 
 	/* Check to see if any memory value is too large for 32-bit and scale
@@ -1081,3 +1109,9 @@ compat_sys_sysinfo(struct compat_sysinfo
 
 	return 0;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/kernel/exec_domain.c linux-2.6.26.1-cher1/kernel/exec_domain.c
--- linux-2.6.26.1/kernel/exec_domain.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/kernel/exec_domain.c	2008-08-05 13:44:37.000000000 +0400
@@ -194,6 +194,9 @@ sys_personality(u_long personality)
 {
 	u_long old = current->personality;
 
+        if (SBOX_IS_RESTRICTED())
+                return (long) old;
+
 	if (personality != 0xffffffff) {
 		set_personality(personality);
 		if (current->personality != personality)
@@ -207,3 +210,9 @@ sys_personality(u_long personality)
 EXPORT_SYMBOL(register_exec_domain);
 EXPORT_SYMBOL(unregister_exec_domain);
 EXPORT_SYMBOL(__set_personality);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
